//+------------------------------------------------------------------+
//|                                                 ay-mpsession.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, ahmad.yani@hotmail.com"
#property link      "http://eyesfx.web44.net"

#property indicator_chart_window


/******************************************************************\\\
 * MP Library 
 * dont change anything in this mp library block, unless YKWYD.....
 ******************************************************************///say something here...
#include <ay-mplib.const.mqh>                                       //
                                                                    //
#import "ay-mplib100.ex4"                                           //
void MpGet                                                          //
   (                                                                //   
        double    dparam[4]                                         //
      , int       iparam[3]                                         //
      , double    arates[][6]                                       //
      , double&   mpdata[][MPSIZE]                                  //result: data
      , int&      mplinesidx[MPLNSIZE]                              //result: lines index
      , double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
      , int&      mpletter[][MPLTSIZE]                              //result: letter  
   );                                                               //
#import                                                             //
/******************************************************************\\\
 * End MP Library 
 ******************************************************************///
 
/******************************************************************\\\
 * Indicator Constant
 ******************************************************************/// 

#define SES_START       0
#define SES_END         1
#define T_SES           0
#define L_SES           1
#define N_SES           2
#define MPLFONTNAME     "Arial"
#define MPLFONTSIZE     8
//#define FONTNAME                    "lucida sans typewriter"
//#define FONTNAME2                   "lucida sans typewriter"
//#define FONTSIZE                    7
//#define FONTSIZE2                   7
/******************************************************************\\\
 * End Indicator Constant
 ******************************************************************/// 

//--- input parameters
extern string     TokyoOpen                = "00:00";
extern string     LondonOpen               = "08:00";
extern string     NewyorkOpen              = "15:30";
extern int        NumDays                  = 10;
extern int        RowHeight                = 3;
extern int        ProfileDataTf            = 30;
extern double     VAPercent                = 70.0;
extern int        IBNumBars                = 2;
extern string     spr1                     = "Colors.............";
extern color      AsColor                  = Green;
extern color      EuColor                  = Blue;
extern color      UsColor                  = Maroon;
extern color      VAColor                  = MistyRose;
extern color      POCColor                 = SteelBlue;
extern color      HistogramColor           = Gainsboro;
extern color      BarBullColor             = DarkGreen;
extern color      BarBearColor             = Crimson;
extern color      BarNetralColor           = DimGray;
extern color      ClosingLetterColor       = Magenta;

//-->global vars
int        giStep
         , giDigits
         , giMpHandle;         
double     gdaRates[][6]
         , gdOneTick
         , gdPoint;     
color      gcHistoColor;         
bool       gbFirstRun = true;
string     gsaLetter[] = 
            {
             "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","P","W","X","Y","Z"
            ,"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","p","w","x","y","z"
            } 
         , gsPref = "ay.mpls."; 
color      gcSesColor[3];            
//<--global vars   
 
#include <ay-object.func.mqh>

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   //giMpHandle = MpInit();   
   
   if (Point == 0.001 || Point == 0.00001) 
   { gdPoint = Point*10; giDigits = Digits - 1; }
   else 
   { gdPoint = Point; giDigits = Digits; } 
   
   gdOneTick = 1/MathPow(10, giDigits);
   
   giStep = MathMax(RowHeight, 1);
   
   ArrayCopyRates(gdaRates, NULL, ProfileDataTf);        
   
   gcSesColor[T_SES] = AsColor;
   gcSesColor[L_SES] = EuColor;
   gcSesColor[N_SES] = UsColor;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   //if (giMpHandle>0) giMpHandle = MpRelease(giMpHandle);
   //Print("deinit, giMpHandle: ", giMpHandle); 
         
   delObjs();
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   
   static bool isbusy;
   if (isbusy) { Print("start() is busy, come back later"); return(0); }   
   if (!isHistoryOK()) return(0);
   if (!secondDiff1()) return(0);
      
   
   isbusy = true; 
   
   //-->Market Session Vars   
   int        iday, ises;   
   datetime   ams[][3][2];       //array market session     
   datetime   dtTO, dtTE, dtLO, dtLE, dtNO, dtNE;
   //<--Market Session Vars   
   
   //-->MpGet Vars
   double     hh, ll, hhday, llday
            , rhh, rhhday  //round hh to rowheight
            , rll, rllday; //round ll to rowheight;
   int        sb, eb, sbday, ebday;    
   double     mpdata  [][MPSIZE];
   int        mplines   [MPLNSIZE];
   double     mptotal   [MPTSIZE];
   int        mpletter[][MPLTSIZE];   
   double     dparam[4];
   int        iparam[3];      
   int        ratessize = iBars(NULL, ProfileDataTf)
            , mpdatasize;
   //<--MpGet Vars   
   
   
   
   double     poc, vah, val, open, close;    
   double     rg = (giStep/1.0)/(MathPow(10,giDigits))
            , ibh, ibl, dibh, dibl;    
   int        maxtpo
            , startday
            , maxdays
            , startprofile, startprofileday
            , laststartprofile = 0
            , space = 4;           
      
   maxdays = NumDays; 
   ArrayResize(ams, maxdays);
   
   for (iday=0; iday<maxdays; iday++)
   {
      dtTO  = StrToTime( TimeToStr( iTime(NULL, PERIOD_D1, iday), TIME_DATE ) + " " + TokyoOpen );
      dtLO  = StrToTime( TimeToStr( iTime(NULL, PERIOD_D1, iday), TIME_DATE ) + " " + LondonOpen );
      if (dtLO<dtTO) dtLO += PERIOD_D1*60;
      dtNO  = StrToTime( TimeToStr( iTime(NULL, PERIOD_D1, iday), TIME_DATE ) + " " + NewyorkOpen );  
      if (dtNO<dtLO) dtNO += PERIOD_D1*60; 
                           
      dtTE  = dtLO - 1; //profile end @LO
      dtLE  = dtNO - 1; //profile end @NO
      dtNE  = dtTO + (PERIOD_D1*60) - 1; //profile end @next TO
      
      ams[iday][T_SES][SES_START]   = dtTO;
      ams[iday][T_SES][SES_END]     = dtTE;      
      
      ams[iday][L_SES][SES_START]   = dtLO;
      ams[iday][L_SES][SES_END]     = dtLE;
               
      ams[iday][N_SES][SES_START]   = dtNO;
      ams[iday][N_SES][SES_END]     = dtNE;
   }         
   
   //when tokyo open start at prev day like at 23:00
   if ( ams[0][T_SES][SES_START] > iTime(NULL, ProfileDataTf, 0) )  
      startday = 1;   
   
   if (!newBarDataTf()) 
   {
      maxdays = startday+1;
      delObjs(gsPref + "#" + startday);
   }
   else 
   {      
      delObjs();
   }   
   
   for (iday=startday; iday<maxdays; iday++)
   {
      //hhday=0; llday=999999999999; 
      //rhhday=0; rllday=999999999999;
      //sbday=0; ebday=999999;
      startprofileday=0;
      
      for (ises=2; ises>=0; ises--)
      {
         if (ams[iday][ises][SES_START] > iTime(NULL, ProfileDataTf, 0) ) continue;
         
         getSesSE
         (
              ProfileDataTf
            , ams[iday][ises][SES_START]
            , ams[iday][ises][SES_END]
            , sb
            , eb
          );
                           
         if (    sb<0 
              || eb<0                  
              || ( TimeDayOfWeek(iTime(NULL, ProfileDataTf, sb)) == 0 && TimeDayOfWeek(iTime(NULL, ProfileDataTf, eb)) == 0 ) 
            ) 
         {
            Print("skipping day#", iday, " ses#", ises, " sb ", sb, " eb ", eb);
            continue;
         }
         
         
         //-->Prepare data for library fn call    
         getHHLL(ProfileDataTf, sb, eb, hh, ll);      
         rhh = MathCeil(hh/rg) * rg;
         rll = MathCeil(ll/rg) * rg;
         if (rhh < hh) rhh += rg;
         //if (rll > ll) rll -= rg;      
      
         dparam[MPDP_ONETICK]    = gdOneTick;
         dparam[MPDP_HH]         = rhh;
         dparam[MPDP_LL]         = ll;
         dparam[MPDP_VAPERCENT]  = VAPercent;

         iparam[MPIP_STARTBAR]   = sb;
         iparam[MPIP_ENDBAR]     = eb; 
         
      
         //-->call library
         MpGet
            (  
                 dparam       //double    dparam[4]
               , iparam       //int       iparam[2]
               , gdaRates     //double    arates[][6]
               , mpdata       //double&   mpdata[][MPSIZE]                                  //result: data
               , mplines      //int&      mplinesidx[MPLNSIZE]                              //result: lines index
               , mptotal      //double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
               , mpletter     //int&      mpletter[][MPLTSIZE]                              //result: letter  
            );
         //<--call library         
      
         mpdatasize = ArraySize(mpdata)/MPSIZE;
         maxtpo = mpdata[ mplines[MPL_TPOPOC] ][MP_TPO];   

         startprofile      = laststartprofile + maxtpo + space;      
         laststartprofile  = startprofile;
         
         drawPriceLetter
         (
              iday               //int    iday
            , ises               //int    ises
            , startprofile       //int    sbprofile
            , sb - eb            //int    totalbar
            , mpdatasize         //int    mpdatasize           
            , mpdata             //double mpdata[][]
            , mplines            //int    mplines[]
            , mpletter           //int    mpletter[][]
            , gcSesColor[ises]   //color  lettercolor
         );   
                       
         open  = iOpen(NULL, ProfileDataTf, sb);
         close = iClose(NULL, ProfileDataTf, eb);      
         drawBar( iday, ises, startprofile+2, open, hh, ll, close );
      
         createRect( "#" + iday + "#" + ises + ".va" 
            , mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE], Time[ startprofile + 1 ]
            , mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE], Time[ startprofile - (maxtpo+1) ]
            , VAColor );          
            
         createTl("#" + iday + ".1.1.#" + ises + ".poc"
            , Time[ startprofile + 1 ]  , mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE]
            , Time[ startprofile - (maxtpo+1) ], mpdata[ mplines[MPL_TPOPOC] ][MP_PRICE]
            , POCColor, STYLE_SOLID, 2, false
            );     
                
         //Session IB                                      
         getHHLL(ProfileDataTf, sb, MathMax(sb-(IBNumBars-1), 0), hh, ll);
                  
         createTl("#" + iday + ".1.1.#" + ises + ".ib"
            , Time[ startprofile + 1 ], hh
            , Time[ startprofile + 1 ], ll
            , Crimson, STYLE_SOLID, 3, false
            );           
            
         getHHLL(ProfileDataTf, sb, MathMax(sb-(IBNumBars-1), 0), ibh, ibl);
         dibh = ibh+(ibh-ibl);
         dibl = ibl-(ibh-ibl);
         createTl("#" + iday + ".1.1.#" + ises + ".5.ib"
            , Time[ startprofile + 1 ], ibh+((ibh-ibl)*0.5)
            , Time[ startprofile + 1 ], ibl-((ibh-ibl)*0.5)
            , SkyBlue, STYLE_SOLID, 3, false
            ); 
         getHHLL(ProfileDataTf, sb, MathMax(sb-(IBNumBars-1), 0), ibh, ibl);
         dibh = ibh+(ibh-ibl);
         dibl = ibl-(ibh-ibl);
         createTl("#" + iday + ".1.1.#" + ises + ".1.ib"
            , Time[ startprofile + 1 ], dibh
            , Time[ startprofile + 1 ], dibl
            , SeaGreen, STYLE_SOLID, 3, false
            );                        

         getHHLL(ProfileDataTf, sb, MathMax(sb-(IBNumBars-1), 0), dibh, dibl);
         dibh = ibh+(ibh-ibl);
         dibl = ibl-(ibh-ibl);
         createTl("#" + iday + ".1.1.#" + ises + ".1.5.ib"
            , Time[ startprofile + 1 ], dibh+((ibh-ibl))
            , Time[ startprofile + 1 ], dibl-((ibh-ibl))
            , DarkGoldenrod, STYLE_SOLID, 3, false
            ); 
         /*getHHLL(ProfileDataTf, sb, MathMax(sb-(IBNumBars-1), 0), dibh, dibl);
         dibh = ibh+(ibh-ibl);
         dibl = ibl-(ibh-ibl);
         createTl("#" + iday + ".1.1.#" + ises + ".1.0.ib"
            , Time[ startprofile + 1 ], dibh+(ibh-ibl)
            , Time[ startprofile + 1 ], dibl-(ibh-ibl)
            , Green, STYLE_SOLID, 3, false
            );*/             

         //-->prepare data for daily profile
         startprofileday = MathMax(startprofileday, startprofile);            
         //<--prepare data for daily profile
         
        // Print(rll," ", rllday);  
      }   
      
      //Comment(rhhday, " ", rllday, " ", ll );
      continue;
      getSesSE
      (
           ProfileDataTf
         , ams[iday][T_SES][SES_START]
         , ams[iday][N_SES][SES_END]
         , sb
         , eb
       );      
      
     if (  sb<0 
        || eb<0                  
        || ( TimeDayOfWeek(iTime(NULL, ProfileDataTf, sb)) == 0 && TimeDayOfWeek(iTime(NULL, ProfileDataTf, eb)) == 0 ) 
      ) 
      {
         Print("skipping day#", iday, " sb ", sb, " eb ", eb);
         continue;
      }
         
      //-->Prepare data for library fn call    
      getHHLL(ProfileDataTf, sb, eb, hh, ll);      
      rhh = MathCeil(hh/rg) * rg;
      rll = MathCeil(ll/rg) * rg;
      if (rhh < hh) rhh += rg;
      if (rll > ll) rll -= rg;      
   
      dparam[MPDP_ONETICK]    = gdOneTick;
      dparam[MPDP_HH]         = rhh;
      dparam[MPDP_LL]         = ll;
      dparam[MPDP_VAPERCENT]  = VAPercent;

      iparam[MPIP_STARTBAR]   = sb;
      iparam[MPIP_ENDBAR]     = eb;
      
      //<--Prepare data for library fn call
      
      //-->call library
      MpGet
         (  
              dparam       //double    dparam[4]
            , iparam       //int       iparam[2]
            , gdaRates     //double    arates[][6]
            , mpdata       //double&   mpdata[][MPSIZE]                                  //result: data
            , mplines      //int&      mplinesidx[MPLNSIZE]                              //result: lines index
            , mptotal      //double&   mptotal[MPTSIZE]                                  //result: total (tpo, vol)
            , mpletter     //int&      mpletter[][MPLTSIZE]                              //result: letter  
         );      
         
      mpdatasize = ArraySize(mpdata)/MPSIZE;
      maxtpo = mpdata[ mplines[MPL_TPOPOC] ][MP_TPO];   
      
      /*createRect( "#" + iday + ".va" 
         , mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE], Time[ startprofileday + 1 ]
         , mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE], Time[ startprofileday - (maxtpo+1) ]
         , HistogramColor, false );  */
      
      drawPriceHistogram
      (
           iday                  //int    iprofile
         , startprofileday          //int    sbprofile
         , sb - eb     //int    totalbar
         , mpdatasize            //int    mpdatasize           
         , mpdata                //double mpdata[][]
         , mplines            //int    mplines[]
      );        
      
   }
        
   if (isbusy) isbusy = false;   
   return(0);
}
/**
 *
 */
void drawBar( int iday, int ises, int pos, double o, double h, double l, double c )
{
   color barclr;
   if (c>o)barclr=BarBullColor; else
   if (c<o)barclr=BarBearColor; else
           barclr=BarNetralColor;   

   createTl("#" + iday + ".1.1.#" + ises + ".bar.spread"
      , Time[pos], h
      , Time[pos], l
      , barclr, STYLE_SOLID, 3, false
      );            
   
   createTl("#" + iday + ".1.1.#" + ises + ".bar.o"
      , MathMax(Time[pos+1], Time[pos] - Period()*60), o
      , Time[pos], o
      , barclr, STYLE_SOLID, 3, false
      ); 
      
   createTl("#" + iday + ".1.1.#" + ises + ".bar.c"
      , MathMax(Time[pos-1], Time[pos] + Period()*60), c
      , Time[pos], c
      , barclr, STYLE_SOLID, 3, false
      );       
}
/**
 *
 */
void drawPriceLetter
(
     int    iday
   , int    ises
   , int    sbprofile
   , int    totalbar
   , int    mpdatasize           
   , double mpdata[][]
   , int    mplines[]
   , int    mpletter[][]
   , color  lettercolor
)
{          
   
   int        maxtpoidx  = mplines[MPL_TPOPOC];
   double     maxtpo     = mpdata[maxtpoidx][MP_TPO];
           
   double     price1, price2
            , numtpo, numvol;
   int        step, step2, stepl
            , i, j, pos, letterid;
   string     letter;
   color      clr;
   
   for (step = 0; step<mpdatasize; step += giStep)
   {
      price1   = mpdata[ step ][MP_PRICE];
      step2    = MathMin(step+giStep, mpdatasize-1);
      price2   = mpdata[ step2 ][MP_PRICE];  
      
      numtpo   = 0;            
      for (i=step; i < step2; i++)
      {         
        if (  mpdata[i][MP_TPO] > numtpo)
        {
            numtpo = mpdata[i][MP_TPO];
            stepl = i;
        } 
      }   

      pos = sbprofile;
      for (j=0; j<512; j++)
      {
         if ( mpletter[stepl][j] == -1) break;
         
         letterid =  mpletter[stepl][j] ;
         if (letterid>50) letterid = MathMod(letterid,50);
         
         letter = gsaLetter[ letterid ];
         
         //if ( /*iday == 0 && */letterid == totalbar )
            //clr = ClosingLetterColor;
         //else clr = lettercolor; 
         
         createText( "#" + iday + ".1.2.#" + ises + ".letter." + step + "-" + j
            , Time[pos]
            , price1
            , letter
            , MPLFONTSIZE, MPLFONTNAME, lettercolor
            );          
         
         pos--;
      }      
   }
   
      
}

/**
 *drawPriceHistogram
 */
void drawPriceHistogram
(
     int    iprofile
   , int    sbprofile
   , int    totalbar
   , int    mpdatasize           
   , double mpdata[][]
   , int    mplines[]
)
{
   
   double   price1, price2, dstep;
   int      inumtpo; 
   double   numtpo, numvol;
   int      step, step2, i;
   datetime t1             = Time[sbprofile+1], t2;
   double   lprice         = mpdata[mpdatasize-1][MP_PRICE]; 
   
   double vah = mpdata[ mplines[MPL_TPOVAH] ] [MP_PRICE];
   double val = mpdata[ mplines[MPL_TPOVAL] ] [MP_PRICE];
   
   //color vars... 
   color clr = HistogramColor;   
   color clr2; //darker color
   
   int  iclr = -64, ired, igreen, iblue;

   intToRGB(clr, ired, igreen, iblue);
   getNextGradColor( iclr, ired, igreen, iblue, true ); 
   clr2 = RGB(ired, igreen, iblue); 
                     
   int stepplus = giStep; //MathMax(MathCeil(((mpdatasize/1.0)/200)), 5); 
   //if (mpdatasize<50) stepplus = 2; 

   for (step=0; step < mpdatasize; step += giStep)      
   {
      price1   = mpdata[ step ][MP_PRICE];
      step2    = MathMin(step+giStep, mpdatasize-1);
      price2   = mpdata[ step2 ][MP_PRICE];     
         
      numtpo   = 0;      
      for (i=step; i < step2; i++)
         numtpo = MathMax( numtpo, mpdata[i][MP_TPO] ); 
                          
      inumtpo = MathRound(numtpo);
                          
      t2 = Time[sbprofile - inumtpo] ;
      
      createRect( "#" + iprofile + ".0.0.0.histoprice.border." + step
         , price1,                  t1
         , MathMax(price2, lprice), t2
         , clr, false );      
      
      if ( price1 <= vah && price1 >= val)
      createRect( "#" + iprofile + ".0.0.0.histoprice.va" + step
         , MathMin(price1, vah), t1
         , MathMax(price2, val), t2
         , clr2 );                                   
                                       
   }          

} 

/**
 *
 */
bool isHistoryOK()
{    
   //if (IsConnected())
   //{
   if (  !checkHist(ProfileDataTf) 
      || !checkHist(PERIOD_D1) 
      //|| !checkHist(Period())
   )  return(false); 
   //}
   Comment("");
   return(true);
}
/**
 *
 */
bool checkHist(int tf)
{

   int i, bars, err;
   
   bars = iBars(Symbol(), tf);      
   err  = GetLastError();   
      
   if (err==0) return(true);
   Comment("Waiting for timeframe ", tf, " minutes to be ready");   
   
   return(false);

}


/**
 *getHHLL                                                          
*/
void getHHLL
(
     int       tf
   , int       sb
   , int       eb
   , double&   hh
   , double&   ll
)
{
   hh = NormalizeDouble(iHigh ( NULL, tf, iHighest(NULL, tf, MODE_HIGH, (sb - eb)+1, eb) ), giDigits);
   ll = NormalizeDouble(iLow  ( NULL, tf, iLowest (NULL, tf, MODE_LOW,  (sb - eb)+1, eb) ), giDigits);
} 
/**
 *getSesSE
 *get startbar and endbar from one session
*/
void getSesSE
(
     int          tf
   , datetime     dtsb
   , datetime     dteb 
   , int&         sb
   , int&         eb
)
{
   sb = iBarShift(NULL, tf, dtsb);
   eb = iBarShift(NULL, tf, dteb);
   
   //fix ibarshift during weekstart, sunday bar..   
   if (iTime(NULL, tf, sb) < dtsb) sb--;  
   if (eb>sb) eb=sb;  
}
/**
 *
 */
bool secondDiff1()
{
   static datetime lasttime ;
   int diff = TimeLocal() - lasttime ;

   if (diff >= 1)
   {
      lasttime = TimeLocal();
      return (true);
   }
   
   return (false);
   
}
/**
 *
 */
bool newBarDataTf()
{
   static datetime LastBar;
   datetime CurrBar = iTime(NULL, ProfileDataTf, 0);

   if(LastBar != CurrBar)
   {
      LastBar = CurrBar;
      return (true);
   }
   return(false);  
}
//+------------------------------------------------------------------+